%if 0
/*-
 * SPDX-License-Identifier: BSD-4-Clause
 *
 * Copyright (c) 1996, Sujal M. Patel
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Sujal M. Patel
 * 4. Neither the name of the author nor the names of any co-contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	$FreeBSD$
 *      from: pnp.h,v 1.7 1998/09/13 22:15:44 eivind Exp
 */
%endif

 _PNP_ADDRESS 	EQU	0x0259		;//PC-98 not PC/AT
 _PNP_WRITE_DATA	EQU	0x0a59		;//
 PNP_SET_RD_DATA	EQU	0x00
PNP_SERIAL_ISOLATION	EQU	0x01
PNP_CONFIG_CONTROL	EQU	0x02
	PNP_CONFIG_CONTROL_RESET_CSN	EQU	0x04
	PNP_CONFIG_CONTROL_WAIT_FOR_KEY	EQU	0x02
	PNP_CONFIG_CONTROL_RESET		EQU	0x01
PNP_WAKE		EQU	0x03
PNP_RESOURCE_DATA	EQU	0x04
PNP_STATUS		EQU	0x05
PNP_SET_CSN		EQU	0x06
PNP_SET_LDN		EQU	0x07
;/*** addresses 0x08 - 0x1F Card Level Reserved for future use ***/
;/*** addresses 0x20 - 0x2F Card Level, Vendor Defined ***/
PNP_ACTIVATE		EQU	0x30
PNP_IO_RANGE_CHECK	EQU	0x31
	PNP_IO_RANGE_CHECK_ENABLE		EQU	0x02
	PNP_IO_RANGE_CHECK_READ_AS_55	EQU	0x01
;/*** addr 0x32 - 0x37 Logical Device Control Reserved for future use ***/
;/*** addr 0x38 - 0x3F Logical Device Control Vendor Define ***/
PNP_MEM_BASE_HIGH	EQU	0x40		;+8*i
PNP_MEM_BASE_LOW	EQU	0x41		;+8*i
PNP_MEM_CONTROL	EQU	0x42		;+8*i
	PNP_MEM_CONTROL_16BIT	EQU	0x2
	PNP_MEM_CONTROL_LIMIT	EQU	0x1
PNP_MEM_RANGE_HIGH	EQU	0x43		;+8*i		iMAX == 3
PNP_MEM_RANGE_LOW	EQU	0x44		;+8*i		iMAX == 3

PNP_IO_BASE_HIGH	EQU	0x60		;+2*i		iMAX == 7
PNP_IO_BASE_LOW	EQU	0x61		;+2*i		iMAX == 7

PNP_IRQ_LEVEL		EQU	0x70		;+2*i		iMax == 1
PNP_IRQ_TYPE		EQU	0x71		;+2*i		iMax == 1

PNP_DMA_CHANNEL	EQU	0x74		;+2*i		iMax == 1

;;この上の定数定義とpnp_send_initiation_keyなどを含む関数の名前をFreeBSDからもらったのでそこはライセンスに従います。
;;それ以外の私が書いた部分に関しては改造自由ですが売ってはいけません。
;;%define CBUS_ROM
;;%define PCI_ROM

%ifdef	PCI_ROM
	ORG	0
db	55h,0aah		;PCI BOOT ROM Signature
db	8h			;PCI ROM size sum==0 needed  512*8=4kByte

	jmp	INIT_PCAT	;PC/AT用コード sum値をずらさせるだけ

times 19 nop
dw	PCIR
dw	PnP

db	'PC98'
	jmp	START		;2byteジャンプ 一つあたり4byteブロック
	nop
	nop

	jmp	INIT2
	nop
	nop

	jmp	INIT3
	nop
	nop

	jmp	INIT4
	nop
	nop

	jmp	INIT5
	nop
	nop

	jmp	INIT6
	nop
	nop

INIT_PCAT:
INIT2:
	mov	byte [cs:2],1h	;ROM SIZE 報告値を変更 すればsumが通らなくなるからPC/ATではまともなことができなくなる
INIT3:					;し PC-98でもRAMに残らなくなる
INIT4:
INIT5:
INIT6:
	retf
	
PnP:	db	24h		;PnP size? '$'
	db	'PnP'
	db	01h		;structure revision
	db	02h		;structure size???
	db	0
	db	0
	db	0
	db	0a4h	
	dw	0490h		;vendor id?	エンディアンが逆で入ってるが
	dw	0011h		;device id?	エンディアンが逆で入ってるが

	dw	0046h		;Manufacture String Pointer	本物の0046h == "Adaptec "
	dw	004eh		;Product Name String	本物の004eh == "AHA-2930U2 "

	db	01h		;device type 1==SCSI
	db	0		;type
	db	0		;type
	db	0074h		;Device Indicator		本物の74h == 00 00 00 00 00 CBh
	dw	0		;Boot Connection Vector
	dw	0079h		;Disconnect Vector		本物の79h == CBh (retf)
	dw	0		;Bootstrap Entry vector	
	dw	0		;???
	dw	0CBh		;Static Res.Info.Vec
	db	0		;CheckSUM


PCIR:	db	'PCIR'		;書き込み対象ごとにそれなりにちゃんと準備しなきゃいけないところ
	dw	9005h		;vendor_id 今回の例はadaptec
	dw	0011h		;device_id 		2930U2で試して動作した
	dw	0		;VPD pointer
	dw	0018h		;PCIR size  24byte
	dw	0		;structure revision
	db	0		;sub class
	db	1		;基本クラス SCSI
	dw	50h		;512byte blocks number
	dw	0		;revision level
	db	0		;code type 00==x86
	db	80h		;インジケータ
	dw	0		;予約	
%else
 %ifdef	CBUS_ROM
	ORG	0

	retf
	nop
	nop

	retf
	nop
	nop

	retf
	nop
	nop

db	55h,0aah	;cbus boot rom signature
	nop

INIT1:
	jmp	START		;INIT1
	nop

INIT2:
	retf			;INIT2
	nop
	nop
INIT3:
	retf			;INIT3
	nop
	nop
INIT4:
	retf			;INIT4		boot
	nop
	nop
INIT5:
	retf			;INIT5		Int1B
	nop
	nop
INIT6:
	retf			;exINIT
	nop
	nop
 %else
	ORG	100h
 %endif
%endif

section .data
eight_bit_machine	db	0
nisepnp:
pcm		dw	0	;f40h
soundid	dw	0	;a460h
wss_fifo	dw	0	;f48h
		dw	0	;[3]
opn		dw	0	;188h
canbe		dw	0	;f4ah
ymf701		dw	0	;548eh
		dw	0	;[7]
joy		dw	0	;1480h
opl3		dw	0	;1488h
midi		dw	0	;148ch
ymf715		dw	0	;480h
		dw	0	;[12]
		dw	0	;[13]
control118	dw	0	;148eh		118ボードとそれ相当のCanBe2だけが持ってる
		dw	0	;[15]
irq_dma	db	0
originalA460h	db	0
opncard	db	0
boardio:	dw	203h-10h
type118:	db	0x68	;全機能ON singleDMA PnP mode 8
scsi_intdma	db	0
opn12		db	0	;動かせないOPNのIRQが既に12を使っていた場合
opn118		db	0	;IO x88hのx部
opnirq:	db	0	;CS4232用IRQ設定(YMF297共用)
id118		db	0C4h	;IO x460hのx4部	だがA460h固定
opl118		db	0	;IO 1x80hの1x部
pnpids:
times 20	db	0
sum9:		db	0	;9byte sumの値
csn:		db	1	;start from 1

%ifdef	PCI_ROM
pnpdata:
times 1000h db 90h
%else
section .bss
pnpdata:	resb	1000h
%endif
	

section .text
;;	call	pnpcheck	;PNPBIOSがあるかのチェッカ なければ終了	あれば99%9821なのでWSS系のPCM音源持ちと見做す
;;	jne	END		;がPnPBIOSは全然役に立たないので見ない

;;	call	nonPNP118	;非PnPの118ボードを見つけてしまったら終了(CanBe音源持ちに118刺す意味ある?)
;;	je	END





CPU 8086	;最初は16bit機の可能性あり 比較ジャンプでこけさせないために指定
START:
%ifdef	CBUS_ROM
;;	mov	byte [cs:000b],10h
;;	cmp	byte [cs:000b],10h
;;	je	START2		;自分自身のセグメントに書き込みできるならRAMボード そのまま使う 不要
	push	es
	push	ds
	mov	ax,0160h	;OS起動前は空いてると確信して使う
	mov	es,ax
	push	cs
	pop	ds
	mov	di,0
	mov	si,0
	mov	cx,1000h	;hつけ忘れ 10進数になっとった 2025-3-29
rep	movsw			;8kBコピー
	pop	ds
	pop	es
	mov	ax,0160h
	push	ax
	mov	ax,START2
	push	ax
	retf			;コピー先での実行だとPnPが設定されてくれない どこで失敗してるかが見えない
%else
 %ifndef PCI_ROM
	pop	dx
	push	cs		;retfで帰るためのセグメントpush
	push	dx
 %endif
%endif
START2:
	mov	dx,60h		;IO 60h LPT data port 入力取れる?
	in	al,dx		;8bitIO機種 超古い機種ね 例えばPC-286VEで68hを読み出してしまう 8bitIOでも開いてる空間探してこないといけない
	mov	ah,al

	mov	dx,0a460h
	in	al,dx
	cmp	al,ah
	jne	thisis16bitIO

	mov	byte [cs:eight_bit_machine],1
thisis16bitIO:
	mov	dx,186h	;決め打ち
	in	al,dx
;;	cmp	al,0c0h	;IO 0C24hの返事は初期値0C0h 書き換え可能だが変更してなければ この値
;;	je	END2
	cmp	al,0ffh	;まあこっちでいいか
	jne	END2

	push	ds
	push	es
	push	cs		;この時点でDS=CSにしておいた方がいい
	pop	ds
	push	cs
	pop	es		;ESもCSと重ねることにする	無意味
	call	check118pnp	;118boardのPNPIDを得られるかのチェッカ 知ってる値でなければ終了
	jnc	MAIN
	pop	es
	pop	ds
END2:
	retf


END:	ret

wait10us:
	push	cx
	mov	cx,7		;10us/1.6us
	jmp	waitloop
wait250us:
	push	cx
	mov	cx,157		;250us/1.6us
waitloop:
	out	5fh,al
	loop	waitloop
	pop	cx
	ret

MAIN:				;実際の処理
	cmp	byte [cs:eight_bit_machine],1	;24h(多分大丈夫) 2bh 2dh(H98用DMAレジスタ)にあれこれ書きまくる 危ない気がする
	je	nonisePNP
	mov	cx,10h
	call	nisePNPcheck	;PnPもどき 内蔵WSS系ボードのIO確保状態チェック IRQもチェックしましょうね(IRQは見ても無意味)
				;ありえる可能性?		A460hとF40hは全機種使う
				;1.CS4231のみ 		上記のみ使用		MIDIやOPL3やOPNは全部開放
				;2.CS4232+YMF288	CanBe音源初期版		OPL3は使えないがMIDIとJOYはIO使ってる 石的にはwavestar相当 86PCMemulatorがないだけ
				;3.CS4232+YMF297	CanBe音源 118相当	全部機能被り
				;4.YMF701のみ		MIDI,JOY系は使用されてる OPNは存在しないがIO確保されている(そのためチップを適切に乗せると鳴る)
				;5.YMF701+YMF288	機能的に118と全機能被り	ただしOPNAとOPL3を同時に鳴らすことが可能
				;6.YMF715のみ		機能的には4と同じ
				;7.YMF715+YMF288	機能的には5と同じ	ただし最終期ノート(Nw150 800x600画面のNr3桁)のみ?
		;ここでWSS系用のDMAは内蔵専用の1にしておきたいがNpでは不可 初期X(CS4231のみだが)の設定変更不可機種もおるはず めんどいなあ…
		;A460hはnonPNPがいなければ118板がもらう 本体側はB46Ehへ動かす	wavestarと合わせたり 118をさらに刺しての3枚刺しは不可
nonisePNP:
	call	nonPNP		;この段階で確認 nonPNPボード(YM2203やYM2608のもの)が開放された後のIO188h,IOA460h(やだなあ…)を使っているかだけ確認
	call	pnp_exe	;後は私が想定するIOportに全部割り当て	複数枚差しまでは考慮不可っす	Windows9xでどういう風に動くか?までやりたいがちょっと後回しで…

	call	nisePNPexe	;本体側の必要そうな機能は戻す
	call	opna_format	;OPNAの初期化とYMF297からCS4232へ入るmixerの設定  timerAを動かす必要ある?
;	call	midi_format	;MIDIの初期化	必要な場合があるらしいので		必要ある?

	pop	es
	pop	ds
	retf		;2025-3-29 発見 retfで終了に変更してたのにそうなってない

pnpcheck:
	mov	dx,0
	mov	ax,0b400h
	int	1ah
	cmp	dx,4341h
	jne	END
	cmp	ah,0
	ret
	
nonPNP118:
	mov	dx,148eh
	mov	al,0
	out	dx,al
	mov	dx,148fh
	in	al,dx
	cmp	al,0f3h	;一致したら 非PnPモードの118ボード存在(設定次第で全部これかどうかを調べ忘れてる)
	ret


pnp_send_initiation_key:
	mov	dx,_PNP_ADDRESS
	mov	al,0
	out	dx,al
	mov	dx,_PNP_ADDRESS
	mov	al,0
	out	dx,al

	mov	ax,0x6a		;cur = 0x006a
	mov	dx,_PNP_ADDRESS
	out	dx,al

	mov	cl,31
send_key:
	mov	bx,ax			;bx = cur
	shr	ax,1			;ax = cur >> 1
	xor	bx,ax			;bx = cur ^ (cur >> 1)
;;	shl	bx,7			; << 7
	shl	bx,1			; << 1
	shl	bx,1			; << 2
	shl	bx,1			; << 3
	shl	bx,1			; << 4
	shl	bx,1			; << 5
	shl	bx,1			; << 6
	shl	bx,1			; << 7
	or	al,bl
	out	dx,al
	loop	send_key
	ret

check118pnp:
%if 0
118ボードはPnPBIOSから無視されるので無意味
	mov	ax,0b402h
	push	cs
	pop	es
	mov	di,pnpdata
	int	1ah

	mov	dx,[es:di]	;PnP cfg table全体サイズ
	mov	bx,0ch
	mov	cl,[es:di+8]
nextcard:
	cmp	dx,bx
	jb	END
	mov	ax,[es:di+bx+4]
	cmp	ax,0A3B8h	;NEC
	je	NEC
nextcard0:
	add	bx,[es:di+bx]	;デバイステーブルサイズ 2byte
	dec	cl
	cmp	cl,0
	je	no118
	jmp	nextcard
%endif

nexttime2:
	mov	byte [cs:csn],1

;Put all cards into the Sleep state so that we can clear
;their CSNs.
	call	pnp_send_initiation_key

;Clear the CSN for all cards.
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_CONFIG_CONTROL
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,PNP_CONFIG_CONTROL_RESET_CSN
	out	dx,al

;Move all cards to the Isolation state.
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_WAKE
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,0
	out	dx,al	

;Tell them where the read point is going to be this time.
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_SET_RD_DATA
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	ax,[cs:boardio]
	add	ax,10h
	mov	[cs:boardio],ax
	cmp	word [cs:boardio],3ffh
	ja	pnpend
;;	shr	ax,2		;203h>>2 == 80h
	shr	ax,1		;203h>>2 == 80h
	shr	ax,1		;203h>>2 == 80h
	out	dx,al


nexttime:
	cmp	byte [cs:csn],8	;8でよいらしい? 16は多すぎるかも 2025-3-29変更
	ja	nexttime2

	mov	dx,_PNP_ADDRESS
	mov	al,PNP_SERIAL_ISOLATION
	out	dx,al
	out	5fh,al
;wait 1ms
	call	wait250us
	call	wait250us
	call	wait250us
	call	wait250us

	push	es		;2025-3-29	ROM上で実行中のESの位置が不定だ
	mov	di,pnpids
	mov	cx,10		;9byteで十分とおもいきや NECボードは10byte?
	xor	ax,ax
	push	cs
	pop	es
rep	stosb
	pop	es

	mov	dx,_PNP_ADDRESS
	mov	al,PNP_SERIAL_ISOLATION
	out	dx,al

	mov	dx,[cs:boardio]
	mov	si,pnpids
	mov	di,0
get_serial:
	in	al,dx
	cmp	al,0x55
	je	OK1
	jmp	NG1
OK1:
	call	wait250us
	in	al,dx
	cmp	al,0aah
	je	OK2
	jmp	NG2
OK2:
	call	wait250us
	push	cx
	mov	ax,di		;繰り返し中の回数を
	mov	cl,8		;8で割って
	div	cl		;現データ位置と
	mov	cl,ah		;あまりをもらう
	mov	bx,1
	shl	bx,cl		;あまりのところのbitを立てる
	pop	cx
	xchg	ax,bx
	xor	bh,bh
	or	[si+bx],al	;そこが現在のデータのbit
	inc	di
	cmp	di,72
	jae	sum_check
	jmp	get_serial
NG1:
	in	al,dx		;読むけど捨てる
NG2:
	call	wait250us
	inc	di
	cmp	di,72
	jae	sum_check
	jmp	get_serial

sum_check:
	mov	si,pnpids
	mov	ax,0x6a
	mov	bx,0
sum_calc:
	add	al,[si+bx]
	inc	bx
	cmp	bx,9			;8byteのサムを見る
	jb	sum_calc
;;	cmp	al,[si+bx]		;あわへん 気にしないで中身確認する どうせ118板しか見ないのだから
;;	jne	nexttime
	cmp	word [si],0		;さすがに0だと見る必要なし
	je	nexttime0
	cmp	al,[si+9]
	je	pnpsumok
	add	al,[si+9]
	mov	[cs:sum9],al
pnpsumok:
;;;NEC:
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_SET_CSN
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,[cs:csn]			;start csn from 1 ,set
	out	dx,al
				;本来はsumが一致したら中身を見る
	mov	si,pnpids
	mov	ax,[si]
	cmp	ax,0a3b8h	;NEC board
	jne	nexttime
	mov	ax,[si+2]
	cmp	al,81h		;118board
	jne	nexttime
	cmp	ax,6881h	;118borad singleDMA MIDI有り  FM両有り	PnP Mode 8
	je	ok118
	cmp	ax,6781h	;118borad singleDMA MIDI無し FM両有り	PnP Mode 7
	je	ok118
	cmp	ax,6681h	;118borad dualDMA MIDI有り  FM両有り	PnP Mode 6
	je	ok118
	cmp	ax,6581h	;118borad dualDMA MIDI無し  FM両有り	PnP Mode 5
	je	ok118
	cmp	ax,6481h	;118borad noPCM MIDI有り 	FM両有り	PnP Mode 4
	je	ok118
	cmp	ax,6381h	;118borad noPCM MIDIなし 	FM両有り	PnP Mode 3
	je	ok118
	cmp	ax,6281h	;118borad noPCM MIDI有り 	OPL有り		PnP Mode 2
	je	ok118
	cmp	ax,6181h	;118borad noPCM MIDIなし 	OPL有り		PnP Mode 1
	je	ok118

	push	es		;2025-3-29
	mov	di,pnpdata
	mov	cx,200h
	xor	ax,ax
	push	cs
	pop	es
rep	stosw
	pop	es
	mov	si,pnpdata
	call	read_resources

nexttime0:
	inc	byte [cs:csn]		;次のデバイス番号予約
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_WAKE
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,0
	out	dx,al

	jmp	nexttime	

ok118:
	mov	[cs:type118],ah

	mov	dx,_PNP_ADDRESS
	mov	al,PNP_SET_CSN
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,[cs:csn]		;start csn from 1 ,set to number
	out	dx,al

	push	es		;2025-3-29
	mov	di,pnpdata
	mov	cx,200h
	xor	ax,ax
	push	cs
	pop	es
rep	stosw
	pop	es
	mov	si,pnpdata
;;	mov	cx,9		;9byte dummy data 違う 118板ではちゃんとしたデータだった
;;	mov	bx,0		;bx0 start
;;	call	get_resource_info
;;	cmp	bx,cx
;;	jne	pnpend		;失敗

	call	read_resources
	jc	pnpend

;
;version 10 10	上位4bitが意味のある数値 PnP version 1.1
;ANSI 文字列 NEC サウンドボード
;ANSI 文字列 PnPID?			この設定を推奨しますが他でも設定できるように考えましょう
;IO設定が8個 IRQが二つ DMAが1つ


; * Put this card back to the Sleep state and
; * simultaneously move all cards which don't have a
; * CSN yet to Isolation state.
noerror118:
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_WAKE
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,0
	out	dx,al		
	clc
	jmp	no118
pnpend:
	stc
no118:
; * Unless we have chosen the wrong read port, all cards will
; * be in Sleep state. Put them back into WaitForKey for
; * now. Their resources will be programmed later.
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_CONFIG_CONTROL
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,PNP_CONFIG_CONTROL_WAIT_FOR_KEY
	out	dx,al	
	ret

read_resources:
	mov	cx,1		;tag data
	mov	bx,0
	call	get_resource_info
	cmp	bx,cx
	jne	error
	test	al,80h		;最後の取得データ
	jne	longdata
;small resource
	push	ax
	xor	cx,cx
	mov	cl,al
	and	cl,7
	mov	bx,0
	call	get_resource_info
	pop	ax
	cmp	bx,cx
	jne	error
;;	shr	al,3
	shr	al,1
	shr	al,1
	shr	al,1
	cmp	al,0xf
	je	finish
	jmp	read_resources
longdata:
	mov	cx,2
	mov	bx,0
	call	get_resource_info
	cmp	bx,cx
	jne	error
	mov	cx,[si-2]
	mov	bx,0
	call	get_resource_info
	cmp	bx,cx
	jne	error
	jmp	read_resources
error:
	stc
	ret
finish:
	clc
	ret
get_resource_info:
;first dummy 9byte data read
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_STATUS
	out	dx,al
	mov	di,0
	mov	dx,[cs:boardio]
wait1:
	call	wait10us
	inc	di
	cmp	di,100
	ja	failed
	in	al,dx
	test	al,1
	je	wait1
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_RESOURCE_DATA
	out	dx,al
	mov	dx,[cs:boardio]
	in	al,dx
	mov	[si+bx],al
	inc	bx
	cmp	bx,cx
	jb	get_resource_info
failed:
	add	si,bx
	ret

nonPNP:
	mov	dx,0ccc0h
	mov	al,33h
	out	dx,al
	or	dl,2
	in	al,dx
	mov	ah,al
	mov	dx,0ccc4h
	in	al,dx
	cmp	al,0ffh
	je	old33c
	and	al,03h
;;	shl	ah,4
	shl	ah,1
	shl	ah,1
	shl	ah,1
	shl	ah,1
	or	al,ah
	mov	[cs:scsi_intdma],al		;PnP SMIT board doesn't use DMA ch????
	jmp	only118
old33c:
	mov	dx,0cc0h
	mov	al,33h
	out	dx,al
	or	dl,2
	in	al,dx
	mov	ah,al
	mov	dx,0cc4h
	in	al,dx
	cmp	al,0ffh
	jne	only118
	and	al,03h
;;	shl	ah,4
	shl	ah,1
	shl	ah,1
	shl	ah,1
	shl	ah,1
	or	al,ah
	mov	[cs:scsi_intdma],al
only118:
	mov	dx,988h
	cmp	byte [cs:eight_bit_machine],1		;60H(GDCのIO)に書き込みをしてしまわないように
	je	nextcheck

	mov	dx,0a460h
	in	al,dx
	mov	[cs:originalA460h],al
	and	al,0f0h
	or	al,1
	out	dx,al

	mov	dx,988h
nextcheck:
	dec	dh
	cmp	dh,9
	jae	END
	in	al,dx
	cmp	al,0ffh
	je	nextcheck

	mov	al,0eh		;port A
	out	dx,al
	mov	dl,8ah
	in	al,dx
	and	al,0c0h
	cmp	al,80h
	jne	next12
	mov	byte [cs:opn12],1
next12:
	mov	cl,dh
	dec	cl		;1個へらさないと…	088hのこと忘れてた… まあいいか…
	mov	ax,1
	shl	ax,cl
	or	[opncard],al
	mov	dl,88h
	jmp	nextcheck

nisePNPcheck:
	dec	cx
	cmp	cx,10h
	jae	END
	mov	dx,0c24h
	mov	al,0e0h
	add	al,cl
	out	dx,al

	mov	dl,2dh		;C2Dh 上位
	in	al,dx
	mov	ah,al
	mov	dl,2bh		;C2Bh 下位
	in	al,dx
	mov	bx,cx
	add	bx,bx
	mov	[nisepnp+bx],ax
	cmp	cl,0
	je	wss_move
	cmp	cl,1
	je	id_move
	cmp	cl,2
	je	fifo_move
	cmp	cl,4
	je	fm_move
	cmp	cl,8
	je	joy_move
	cmp	cl,9
	je	opl_move
	cmp	cl,0ah
	je	midi_move
	cmp	cl,0bh
	jne	nisePNPcheck
	mov	al,4
	out	dx,al
	mov	dl,2bh
	mov	al,90h		;YMF715専用portを
	out	dx,al		;490hに変更		必要か?
	jmp	nisePNPcheck
wss_move:
	push	dx
	mov	dx,[cs:pcm]
	in	al,dx
	mov	[cs:irq_dma],al
	pop	dx
	mov	al,90h
	out	dx,al
	mov	al,0fh		;IO F90hに変更 空いてるはず?
	mov	dl,2dh
	out	dx,al

	jmp	nisePNPcheck
id_move:
	mov	al,6Eh
	out	dx,al
	mov	al,0B4h	;一応wavestarとかのことも考えて? B46Ehに動かす さすがに空いてるはず
	mov	dl,2dh
	out	dx,al
	in	al,dx
	cmp	al,0B4h
	jne	no_move	;動かせない機種は存在する
	mov	dx,0B46Eh
	jmp	moved
no_move:
	mov	dx,0a460h
moved:
	in	al,dx
	and	al,0f0h
	or	al,01h		;OPN側有効にしておく このときはOPL側無効で構わない
	out	dx,al
	jmp	nisePNPcheck
fifo_move:
	mov	al,98h
	out	dx,al
	mov	al,0fh		;IO F98hに変更 空いてるはず?
	mov	dl,2dh
	out	dx,al
	jmp	nisePNPcheck
fm_move:
	mov	al,88h
	out	dx,al
	mov	al,11h		;OPNだけはなんも考えずにとりあえず1188hに移動させる
	mov	dl,2dh		;あとで空いてるところに移し替える
	out	dx,al
	jmp	nisePNPcheck
joy_move:
opl_move:
midi_move:
	mov	al,15h		;1480h系は全部15**hに
	mov	dl,2dh
	out	dx,al
	jmp	nisePNPcheck

pnp_exe:
	mov	si,pnpdata
nexttag:
	mov	al,[si]
	inc	si
	test	al,80h
	jne	longdata_e
;;	shr	al,3
	shr	al,1
	shr	al,1
	shr	al,1
	cmp	al,0fh
	je	exe_end
	cmp	al,2		;tag == logical_device
	je	pnp_exe2
	mov	al,[si-1]
	and	ax,7
	add	si,ax
	jmp	nexttag
longdata_e:
	mov	ax,[si]
	add	si,ax
	add	si,2
	jmp	nexttag	
exe_end:
	ret
pnp_exe2:	;;si=logical_device_tag + 1
	;quirks持ちのやらなあかんデバイスにはやる 118板は不要 Gravis UltraSoundやSoundBlaster系だけっぽい?
	mov	ax,[si]
	cmp	ax,0a3b8h	;NECか再度チェック
	jne	exe_end
;;	cmp	si,81h
;;	jne	exe_end	;118板かまたチェック  ここを作り直せば他板もpnp設定できまっせ	
	mov	al,[si+5]
	cmp	al,[cs:sum9]
	je	pnp_exe3	;確認だけしてみる 一致するのでは? しないよ
pnp_exe3:
	call	pnp_send_initiation_key
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_WAKE
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,[cs:csn]			;csn was set before
	out	dx,al	

	mov	di,nisepnp		;参照用nisepnp data
	mov	si,[si+2]
	cmp	si,6881h
	je	pnp8
	cmp	si,6781h
	je	pnp7
	cmp	si,6681h
	je	pnp6
	cmp	si,6581h
	je	pnp5
	cmp	si,6481h
;	je	pnp4
	cmp	si,6381h
;	je	pnp3
	cmp	si,6281h
;	je	pnp2
	cmp	si,6181h
;	je	pnp1
	jmp	exe_end
pnp8:
pnp7:
pnp6:
pnp5:
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_SET_LDN
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,0			;同設定pnp118の2枚刺しには非対応 LDN==0
	out	dx,al			;もっと詰めたい人は自動ツールではないものをお使いください

	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IO_BASE_HIGH
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,04h
	cmp	word [cs:ymf715],480h
	je	set580h
	jmp	set480h			;2000hからの8byte
set580h:
	mov	al,05h
set480h:
	out	dx,al
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IO_BASE_LOW		;480h or 580h
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,80h
	out	dx,al


	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IO_BASE_HIGH+2	;1000hからの16byte
	out	dx,al

	mov	dx,1480h
	in	al,dx
	mov	ah,al
	mov	al,14h				;動かせないなら1480hではなく1580hをもらう
	cmp	ah,0ffh			;直接値を確認する
	je	OK1480h
	mov	al,15h
OK1480h:
	mov	dx,_PNP_WRITE_DATA
	out	dx,al
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IO_BASE_LOW+2
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,80h
	out	dx,al

;;	cmp	word [cs:opn],0
;;	je

	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IO_BASE_HIGH+2*2	;2000hからの8byte
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,1h				;後で弄る 今は188h固定
	test	byte [cs:opncard],1
	je	OPNok
	mov	al,2
	test	byte [cs:opncard],2
	je	OPNok
	mov	al,3
	test	byte [cs:opncard],4
	je	OPNok
	mov	al,4
	test	byte [cs:opncard],8
	je	OPNok
	mov	al,5
	test	byte [cs:opncard],10h
	je	OPNok
	mov	al,6
	test	byte [cs:opncard],20h
	je	OPNok
	mov	al,7
	test	byte [cs:opncard],40h
	je	OPNok
	mov	al,8
	test	byte [cs:opncard],80h
	je	OPNok
	mov	al,9
OPNok:
	mov	bx,1
	mov	cl,al
	dec	cl
	shl	bx,cl
	or	[cs:opncard],bl
	out	dx,al
	mov	[cs:opn118],al		;後で見るようの保管
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IO_BASE_LOW+2*2
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,88h
	out	dx,al

	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IO_BASE_HIGH+2*3	;2000hからの2byte
	out	dx,al
	mov	dx,_PNP_WRITE_DATA

	cmp	byte [cs:eight_bit_machine],1
	je	A460hNG

	mov	al,0A4h				;A460hがもらえるなら奪う
	cmp	byte [cs:originalA460h],0ffh	;16bitIO機種では確認できる
	jne	A460hNG

	mov	[cs:id118],al		;ここではA460hをもらう
	out	dx,al
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IO_BASE_LOW+2*3
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,60h
	out	dx,al
	jmp	A460hOK

A460hNG:
	mov	al,01h				;さすがに0184hは空いてると思う
	out	dx,al				;184hがPnP118板のSoundID ここのbit1がYMF297のN/Lピンとつながってるはず
	mov	dx,_PNP_ADDRESS		;なので本来は知られている場所に配置しておきたい
	mov	al,PNP_IO_BASE_LOW+2*3	;が8bitIO機種ではデコードされうる場所にしないといけない
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,84h
	out	dx,al

A460hOK:
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IO_BASE_HIGH+2*4	;IO C24hと同等機能のはずだがPnPモードでは無効のものを使用済フラグに使う
	out	dx,al
	mov	dx,_PNP_WRITE_DATA		;チェッカに使うIOは
	mov	al,01h				;186hにしておこう	C000hからの1000hはPCIが使う可能性がある し8bitIO機種の場合を考慮
	out	dx,al
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IO_BASE_LOW+2*4
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,86h
	out	dx,al


;;	cmp	byte [cs:eight_bit_machine],1	;;PC-286VEでは大丈夫だったので LPTポートと分離されてた のでF40hを取る
;;	je	F40hNG

	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IO_BASE_HIGH+2*7	;0000hからの16byte
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,0Fh				;WSSが存在するならF50h
	out	dx,al
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IO_BASE_LOW+2*7
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,50h
	cmp	word [cs:pcm],0f40h
	je	F50hPCM
	mov	al,40h				;元のWSS系がいないならF40hをもらう
F50hPCM:
	out	dx,al

	cmp	byte [cs:type118],67h		;noMIDI singleDMA
	je	noMIDI
	cmp	byte [cs:type118],65h		;noMIDI dualDMA
	je	noMIDI

	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IRQ_LEVEL
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,10				;MIDI IRQ10
	out	dx,al
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IRQ_TYPE
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,2h				;レベル割り込み エッジ割り込み選択?
	out	dx,al
	jmp	MIDIon


F40hNG:
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IO_BASE_HIGH+2*7	;0000hからの16byte
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,0Fh				;FD0h	さすがにこの場所からの連続16byteは空いてる想定
	out	dx,al
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IO_BASE_LOW+2*7
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,0D0h
	jmp	F50hPCM

noMIDI:
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IRQ_LEVEL		;MIDIなしのときはこっちがCS4232用割り込み
	out	dx,al
	mov	dx,_PNP_WRITE_DATA

	mov	al,[cs:irq_dma]
;;	shr	al,3
	shr	al,1
	shr	al,1
	shr	al,1
	and	al,7
	cmp	al,4
	je	else12nomidi
	mov	al,12	
	cmp	byte [cs:opn12],0
	jne	else12nomidi
	jmp	ok12nomidi
else12nomidi:
	mov	al,10
ok12nomidi:
	mov	[cs:opnirq],al
	out	dx,al
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IRQ_TYPE
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,2h				;エッジ割り込み?
	out	dx,al
	jmp	noMIDI2

MIDIon:
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IRQ_LEVEL+1*2
	out	dx,al
	mov	dx,_PNP_WRITE_DATA

	mov	al,[cs:irq_dma]
;;	shr	al,3
	shr	al,1
	shr	al,1
	shr	al,1
	and	al,7
	cmp	al,4
	je	else12
	mov	al,12				;OPN3 & CS4231用 IRQ			ジャンパ設定に強制される!!!!この数値は無効 何をいれても同じ
	cmp	byte [cs:opn12],0		;非PnPカードがIRQ12を使っていたら避ける
	jne	else12
	jmp	ok12
else12:
	mov	al,10				;IRQ10 さすがに空いてると思う… 思うだけ
ok12:
	mov	[cs:opnirq],al
	out	dx,al				;ここでPnP番号の設定をやってもIOregister0ehの返事はジャンパ設定に強制される ここを見るまともなソフトで問題が起きる
	mov	dx,_PNP_ADDRESS		;ここで設定しているのはCS4231側の割り込みと考えてよい YMF297の割り込み番号はジャンパ設定 ただし板全体としては同じ番号になっている
	mov	al,PNP_IRQ_TYPE+1*2
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,2h				;エッジ割り込み?
	out	dx,al

noMIDI2:
;;66h 65hは録音用DMAchを欲しがる設定だが無視する	再生専用で	これも必要なら手作業でやってくださいな
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_DMA_CHANNEL
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	ah,[cs:scsi_intdma]		;0 or 3   if 1?
	and	ah,3
	mov	al,3
	sub	al,ah				;SCSIのDMA番号とは逆を使う
	cmp	al,2
	jne	dmaok
	mov	al,3				;強制的に3に変更
dmaok:
	out	dx,al				;
	push	ax	;メモリつかうほどじゃない

	mov	dx,_PNP_ADDRESS
	mov	al,PNP_ACTIVATE
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,1				;activate
	out	dx,al


;Wake everyone up again, we are finished.
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_CONFIG_CONTROL
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,PNP_CONFIG_CONTROL_WAIT_FOR_KEY
	out	dx,al

	mov	dx,0184h		;SoundID184h決め打ち
	in	al,dx
	and	al,0f0h
	or	al,1			;おそらく188hしか開いてないから18Aを開けるためのことをやっておく
	out	dx,al


	mov	dl,88h
	mov	dh,[cs:opn118]
	mov	al,0eh			;IRQ check
	out	dx,al
	mov	dl,8ah
	in	al,dx
;;	shr	al,6
	shr	al,1
	shr	al,1
	shr	al,1
	shr	al,1
	shr	al,1
	shr	al,1
	mov	ah,al			;00b=IRQ3(INT0), 01b=IRQ13(INT6), 10b=IRQ10(INT41), 11b=IRQ12(INT5)
	cmp	ah,0			;IRQ13はCS4232は使えない
	je	IRQ3
	cmp	ah,10b
	je	IRQ10
;;それ以外ならIRQ12で	IRQ13はPCM側は不可	こういうところを本来は自動でやりたい
	mov	ah,20h			;IRQ12
	jmp	PCM
IRQ3:
	mov	ah,8
	jmp	PCM
IRQ10:
	mov	ah,18h
PCM:
	mov	dx,0f40h
	cmp	word [cs:pcm],0f40h
	je	PCMf50h
	jmp	PCMok
PCMf50h:
	mov	dx,0f50h
PCMok:
;;	in	al,dx		;PCM dma & irq setting   IRQ auto setting?
;;	and	al,0f8h	;DMA setting clear
	pop	bx	;取り出してきて
	mov	al,bl
	or	al,1		;DMA use 0 or 3

	and	ah,38h		;No IRQ didn't set by auto	and same with YMF297
	or	al,ah
	out	dx,al		;DMA set

	mov	al,[cs:opnirq]
	cmp	ah,8
	je	IRQ3FM
	cmp	ah,18h
	je	IRQ10FM
;;IRQ12
	cmp	al,12
	je	noerror118
	mov	al,12
	jmp	reexe
IRQ3FM:
	mov	al,3
	jmp	reexe		;3の設定は作ってないからもしジャンパが3だったなら必ず飛ぶ
IRQ10FM:
	cmp	al,10		;自動で10にいった場合にジャンパ設定がうまかったら飛ばない
	je	noexecute
	mov	al,10
	jmp	reexe	
noexecute:
	jmp	noerror118
;;	ret

reexe:
	push	ax
	call	pnp_send_initiation_key
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_WAKE
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,[cs:csn]			;すでに起きてる気がするが一応
	out	dx,al

	mov	dx,_PNP_ADDRESS
	mov	al,PNP_SET_LDN
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,0			;同じ番号なので不要の気がするが LDN==0
	out	dx,al			;

	cmp	byte [cs:type118],67h
	je	reexe_noMIDI
	cmp	byte [cs:type118],65h
	je	reexe_noMIDI

	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IRQ_LEVEL+1*2
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	pop	ax				;YMF297ジャンパ設定割り込みをCS4232割り込みに使う
	out	dx,al
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IRQ_TYPE+1*2
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,2h				;エッジ割り込み選択?
	out	dx,al
	jmp	reexe2

reexe_noMIDI:
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IRQ_LEVEL
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	pop	ax				;YMF297ジャンパ設定割り込みをCS4232割り込みに使う
	out	dx,al
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_IRQ_TYPE
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,2h				;エッジ割り込み選択?
	out	dx,al

reexe2:
	mov	dx,_PNP_ADDRESS
	mov	al,PNP_ACTIVATE
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,1				;activate
	out	dx,al

	mov	dx,_PNP_ADDRESS
	mov	al,PNP_CONFIG_CONTROL
	out	dx,al
	mov	dx,_PNP_WRITE_DATA
	mov	al,PNP_CONFIG_CONTROL_WAIT_FOR_KEY
	out	dx,al

	jmp	noerror118

nisePNPexe:
	cmp	word [cs:soundid],0a460h
	jne	noexecute

	mov	dx,0c24h
	mov	al,0e0h
	out	dx,al
	mov	dx,0c2dh
	mov	al,[cs:pcm+1]
	out	dx,al
	mov	dl,2bh
	mov	al,[cs:pcm]
	out	dx,al

	mov	dx,0c24h
	mov	al,0e1h
	out	dx,al
	mov	dx,0c2dh
	mov	al,0b4h
	out	dx,al
	mov	dl,2bh
	mov	al,6eh			;b46eh		
	out	dx,al

	mov	dx,0c24h
	mov	al,0e2h
	out	dx,al
	mov	dx,0c2dh
	mov	al,[cs:wss_fifo+1]
	out	dx,al
	mov	dl,2bh
	mov	al,[cs:wss_fifo]
	out	dx,al

	mov	dx,0c24h
	mov	al,0ebh
	out	dx,al
	mov	dx,0c2dh
	mov	al,[cs:ymf715+1]
	out	dx,al
	mov	dl,2bh
	mov	al,[cs:ymf715]
	out	dx,al

	cmp	word [cs:opn],188h
	jne	noexecute

	mov	dx,0c24h
	mov	al,0e4h
	out	dx,al
	mov	dx,0c2dh

	mov	al,1			;ありえない
	test	byte [cs:opncard],1
	je	OPNAok
	mov	al,2
	test	byte [cs:opncard],2
	je	OPNAok
	mov	al,3
	test	byte [cs:opncard],4
	je	OPNAok
	mov	al,4
	test	byte [cs:opncard],8
	je	OPNAok
	mov	al,5
	test	byte [cs:opncard],10h
	je	OPNAok
	mov	al,6
	test	byte [cs:opncard],20h
	je	OPNAok
	mov	al,7
	test	byte [cs:opncard],40h
	je	OPNAok
	mov	al,8
	test	byte [cs:opncard],80h
	je	OPNAok
	mov	al,9
OPNAok:
	push	ax	;OPN用IO上位bit
	out	dx,al
	mov	dl,2bh
	mov	al,88h
	out	dx,al
	pop	bx

	mov	dx,0184h		;pnp118 soundIDがここにおるかの確認
	in	al,dx
	cmp	al,0ffh
	je	OK_A460isInternal
;;B46Ehに内蔵サウンドのSOUNDIDが隠れてる状態のとき
	mov	dx,bx
	mov	dl,88h
	in	al,dx
	cmp	al,0ffh
	jne	OK_188isEnable	;YMF701機に増設でYMF288を載せている時はジャンプ
	mov	dx,0B46Eh		;そうでなかったら内蔵側SOUNID IDの?
	in	al,dx
	and	al,0f0h		;bit1をたてておく
	or	al,02h			;YMF701/715機でOPL側を有効にする ここに着たということは内蔵サウンド側としてIO 1588hが開くはず
	out	dx,al
OK_188isEnable:	
OK_A460isInternal:
	ret

opna_format:
ret	;;不要と判断
	mov	dh,[cs:id118]
	mov	dl,60h
	in	al,dx
	and	al,0f0h
	or	al,02h		;OPL mode
	out	dx,al

	mov	dh,[opl118]
	mov	dl,8ah
	mov	al,5
	out	dx,al
	out	5fh,al
	out	5fh,al
	out	5fh,al
	out	5fh,al
	out	5fh,al

	mov	dl,8bh
	in	al,dx
	or	al,5		;YMF-289 NEW3bit Newbit 両方ON
	out	dx,al
	out	5fh,al
	out	5fh,al
	out	5fh,al
	out	5fh,al
	out	5fh,al

	mov	dh,[cs:id118]
	mov	dl,60h
	in	al,dx
	and	al,0f0h
	or	al,01h		;OPN3 mode
	out	dx,al


	mov	dh,[cs:opn118]
	mov	dl,88h
	mov	al,0f7h	;register F7h write
	out	dx,al		;https://pcm1723.hateblo.jp/entry/20140803/1407074615
	out	5fh,al
	out	5fh,al
	out	5fh,al
	out	5fh,al
	out	5fh,al
	mov	dl,8ah
	out	dx,al
	out	5fh,al
	out	5fh,al
	out	5fh,al
	out	5fh,al
	out	5fh,al


	mov	dh,[cs:opn118]
	mov	dl,88h
	mov	al,20h		;register 20h write
	out	dx,al		;https://pcm1723.hateblo.jp/entry/20140803/1407074615
	out	5fh,al
	out	5fh,al
	out	5fh,al
	out	5fh,al
	out	5fh,al
	mov	dl,8ah
	mov	al,02h		;YMF-288 new bit ON
	out	dx,al
	out	5fh,al
	out	5fh,al
	out	5fh,al
	out	5fh,al
	out	5fh,al

	ret